#/bin/sh
 
if [ "$JAVA_HOME" = "" ]; then
    echo "[helloworld][error] JAVA_HOME environment variable not set."
    echo "[helloworld][debug] Aborting."
    exit
fi

if [ "$HOTSWAP_HOME" = "" ]; then
    echo "[helloworld][warn] HOTSWAP_HOME environment variable not set, using CWD instead ($PWD)."
    HOTSWAP_HOME=$PWD
fi

# System stuff.  
JAVA=$JAVA_HOME/bin/java
TOOLSJAR=$JAVA_HOME/lib/tools.jar

# Arguments for the ProxyCompiler
PROPERTIES=$HOTSWAP_HOME/examples/examples.properties
CLASSPATH=$HOTSWAP_HOME/lib/hotswap.jar:$TOOLSJAR
CLASSNAME=HelloWorld

CMD="$JAVA -classpath $CLASSPATH \
 -Dorg.inxar.hotswap.properties=$PROPERTIES \
 example.Main $CLASSNAME"

echo "[helloworld][debug] $CMD"

$CMD

echo "[helloworld][debug] Done."
