import java.util.Date;
import example.Example;
import org.inxar.hotswap.ProxyObject;

public class HelloWorld implements Example, ProxyObject
{
    // the message of this class
    static String msg = "Hello World!";

    public HelloWorld()
    {
	this.birthdate = new Date();
	this.generation = new Integer(0);
    }

    public String toString()
    {
	Class cls = this.getClass();
	ClassLoader loader = cls.getClassLoader();

	return NL + msg + NL +
	    " - originally born " + birthdate + NL +  
	    " - now in generation " + generation + NL + 
	    " - current Object identity: " + System.identityHashCode(this) + NL +
	    " - current Class identity: " + cls.getName() + 
	    " " + System.identityHashCode(cls)+ NL +
	    " - current ClassLoader identity: " + loader.getClass().getName() + 
	    " " + System.identityHashCode(loader) + NL +
	    " - parent ClassLoader identity: " + loader.getParent().getClass().getName() + 
	    " " + System.identityHashCode(loader.getParent()) + NL + NL + 
	    "Edit my sourcefile now to watch changes!" + NL + 
	    "To halt, set the return value of getSleepMillis() to a negative value." + NL;
    }

    public void execute()
    {
	System.out.println(this);
    }

    public long getSleepMillis()
    {
	return 2000;
    }

    public boolean hotswap_onPrepare(ProxyObject po)
    {
	//System.out.println("[HelloWorld] Preparing...");
	
	try {
	    /* uncomment the next line and see what happens */
	    //HelloWorld h = (HelloWorld)po;

	    this.tmp_birthdate = (Date)po.hotswap_get("birthdate");
	    this.tmp_generation = (Integer)po.hotswap_get("generation");

	} catch (Exception ex) {
	    ex.printStackTrace();
	    return false;
	}
    
	return true;
    }

    public void hotswap_onCommit()
    {
	//System.out.println("[HelloWorld] Committing...");
	
	this.birthdate = tmp_birthdate;
	if (tmp_generation != null)
	    this.generation = new Integer(tmp_generation.intValue() + 1);
	this.tmp_birthdate = null;
	this.tmp_generation = null;
    }

    public void hotswap_onRollback()
    {
	//System.out.println("[HelloWorld] Rolling back...");

	this.tmp_birthdate = null;
	this.tmp_generation = null;
    }

    public void hotswap_onRelease()
    {
	//System.out.println("[HelloWorld] Goodbye world...");

	this.birthdate = null;
	this.generation = null;
	this.tmp_birthdate = null;
	this.tmp_generation = null;
    }
    
    public Object hotswap_get(Object key)
    {
	if ("birthdate".equals(key))
	    return birthdate;
	else if ("generation".equals(key))
	    return generation;
	else
	    return null;
    }

    Date birthdate;		// time of first generation 
    Integer generation;		// the number of hotswaps since start

    Date tmp_birthdate;		// temporary time of first generation
    Integer tmp_generation;	// temporary number of hotswaps since start

    private static final String NL = System.getProperty("line.separator");
}

