/**
 * $Id: ProxyEventListener.java,v 1.4 2001/07/27 00:32:16 pcj Exp $
 *
 * Copyright (C) 2001 Paul Cody Johnston - pcj@inxar.org
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA.
 **/
package org.inxar.hotswap;

import java.util.EventListener;

/**
 * Implemented by subjects interested in receiving
 * <code>ProxyEvent</code> messages.
 *
 * @since 0.8.2
**/
public interface ProxyEventListener extends EventListener
{
    /**
     * Receive notification of the given <code>ProxyEvent</code>.
    **/
    void notify(ProxyEvent evt);
}
